/* accelerator.c generated by valac 0.46.6, the Vala compiler
 * generated from accelerator.vala, do not modify */

/*
 * based on keyboard-shortcuts.c from gnome-control-center
 *
 * Copyright (c) 2013 gnome-pomodoro contributors
 *               2010 Intel, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *          Thomas Wood <thomas.wood@intel.com>
 *          Rodrigo Moya <rodrigo@gnome.org>
 */
/* TODO:
 * Handle integration with window manager
 *  - suppress any keybings from being triggered
 *  - if keybinding is taken, notify about it
 *
 * For now gnome-shell extension is responsible for setting it.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#define POMODORO_TYPE_ACCELERATOR (pomodoro_accelerator_get_type ())
#define POMODORO_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator))
#define POMODORO_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))
#define POMODORO_IS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_IS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))

typedef struct _PomodoroAccelerator PomodoroAccelerator;
typedef struct _PomodoroAcceleratorClass PomodoroAcceleratorClass;
typedef struct _PomodoroAcceleratorPrivate PomodoroAcceleratorPrivate;
enum  {
	POMODORO_ACCELERATOR_0_PROPERTY,
	POMODORO_ACCELERATOR_NAME_PROPERTY,
	POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY,
	POMODORO_ACCELERATOR_NUM_PROPERTIES
};
static GParamSpec* pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	POMODORO_ACCELERATOR_CHANGED_SIGNAL,
	POMODORO_ACCELERATOR_NUM_SIGNALS
};
static guint pomodoro_accelerator_signals[POMODORO_ACCELERATOR_NUM_SIGNALS] = {0};

typedef enum  {
	POMODORO_ACCELERATOR_ERROR_INVALID,
	POMODORO_ACCELERATOR_ERROR_FORBIDDEN,
	POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION
} PomodoroAcceleratorError;
#define POMODORO_ACCELERATOR_ERROR pomodoro_accelerator_error_quark ()
struct _PomodoroAccelerator {
	GObject parent_instance;
	PomodoroAcceleratorPrivate * priv;
};

struct _PomodoroAcceleratorClass {
	GObjectClass parent_class;
	void (*changed) (PomodoroAccelerator* self);
};

struct _PomodoroAcceleratorPrivate {
	guint _key;
	GdkModifierType _modifiers;
};

static gint PomodoroAccelerator_private_offset;
static gpointer pomodoro_accelerator_parent_class = NULL;

GQuark pomodoro_accelerator_error_quark (void);
GType pomodoro_accelerator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PomodoroAccelerator, g_object_unref)
PomodoroAccelerator* pomodoro_accelerator_new_from_name (const gchar* name);
PomodoroAccelerator* pomodoro_accelerator_construct_from_name (GType object_type,
                                                               const gchar* name);
void pomodoro_accelerator_set_name (PomodoroAccelerator* self,
                                    const gchar* value);
static void pomodoro_accelerator_parse (const gchar* name,
                                 guint* keyval,
                                 GdkModifierType* modifiers);
void pomodoro_accelerator_unset (PomodoroAccelerator* self);
static void pomodoro_accelerator_set_key (PomodoroAccelerator* self,
                                   guint value);
static void pomodoro_accelerator_set_modifiers (PomodoroAccelerator* self,
                                         GdkModifierType value);
static void pomodoro_accelerator_normalize (guint* keyval,
                                     GdkModifierType* modifiers);
void pomodoro_accelerator_set_keyval (PomodoroAccelerator* self,
                                      guint keyval,
                                      GdkModifierType modifiers);
static guint pomodoro_accelerator_get_key (PomodoroAccelerator* self);
static GdkModifierType pomodoro_accelerator_get_modifiers (PomodoroAccelerator* self);
void pomodoro_accelerator_validate (PomodoroAccelerator* self,
                                    GError** error);
static gchar** pomodoro_accelerator_get_keys_internal (PomodoroAccelerator* self,
                                                gboolean escape,
                                                gint* result_length1);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gchar** pomodoro_accelerator_get_keys (PomodoroAccelerator* self,
                                       gint* result_length1);
PomodoroAccelerator* pomodoro_accelerator_new (void);
PomodoroAccelerator* pomodoro_accelerator_construct (GType object_type);
gchar* pomodoro_accelerator_get_name (PomodoroAccelerator* self);
gchar* pomodoro_accelerator_get_display_name (PomodoroAccelerator* self);
static void pomodoro_accelerator_real_changed (PomodoroAccelerator* self);
static void pomodoro_accelerator_finalize (GObject * obj);
static void _vala_pomodoro_accelerator_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_pomodoro_accelerator_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

GQuark
pomodoro_accelerator_error_quark (void)
{
	return g_quark_from_static_string ("pomodoro-accelerator-error-quark");
}

static inline gpointer
pomodoro_accelerator_get_instance_private (PomodoroAccelerator* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroAccelerator_private_offset);
}

PomodoroAccelerator*
pomodoro_accelerator_construct_from_name (GType object_type,
                                          const gchar* name)
{
	PomodoroAccelerator * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (PomodoroAccelerator*) g_object_new (object_type, NULL);
	pomodoro_accelerator_set_name (self, name);
	return self;
}

PomodoroAccelerator*
pomodoro_accelerator_new_from_name (const gchar* name)
{
	return pomodoro_accelerator_construct_from_name (POMODORO_TYPE_ACCELERATOR, name);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static void
pomodoro_accelerator_parse (const gchar* name,
                            guint* keyval,
                            GdkModifierType* modifiers)
{
	guint _vala_keyval = 0U;
	GdkModifierType _vala_modifiers = 0U;
	gint pos = 0;
	gint start = 0;
	gchar chr = '\0';
	gboolean is_modifier = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp14_;
	gchar* _tmp15_;
	pos = 0;
	start = 0;
	chr = '\0';
	is_modifier = FALSE;
	_vala_keyval = (guint) 0;
	_vala_modifiers = 0;
	if (name == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (name, "") == 0;
	}
	if (_tmp0_) {
		if (keyval) {
			*keyval = _vala_keyval;
		}
		if (modifiers) {
			*modifiers = _vala_modifiers;
		}
		return;
	}
	while (TRUE) {
		gint _tmp13_;
		chr = string_get (name, (glong) pos);
		if (!(chr != '\0')) {
			break;
		}
		if (chr == '<') {
			start = pos + 1;
			is_modifier = TRUE;
		} else {
			gboolean _tmp1_ = FALSE;
			if (chr == '>') {
				_tmp1_ = is_modifier;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				gchar* modifier = NULL;
				gchar* _tmp2_;
				gboolean _tmp3_ = FALSE;
				const gchar* _tmp4_;
				const gchar* _tmp7_;
				const gchar* _tmp9_;
				const gchar* _tmp11_;
				_tmp2_ = string_slice (name, (glong) start, (glong) pos);
				modifier = _tmp2_;
				_tmp4_ = modifier;
				if (g_strcmp0 (_tmp4_, "Ctrl") == 0) {
					_tmp3_ = TRUE;
				} else {
					const gchar* _tmp5_;
					_tmp5_ = modifier;
					_tmp3_ = g_strcmp0 (_tmp5_, "Control") == 0;
				}
				if (_tmp3_) {
					GdkModifierType _tmp6_;
					_tmp6_ = _vala_modifiers;
					_vala_modifiers = _tmp6_ | GDK_CONTROL_MASK;
				}
				_tmp7_ = modifier;
				if (g_strcmp0 (_tmp7_, "Alt") == 0) {
					GdkModifierType _tmp8_;
					_tmp8_ = _vala_modifiers;
					_vala_modifiers = _tmp8_ | GDK_MOD1_MASK;
				}
				_tmp9_ = modifier;
				if (g_strcmp0 (_tmp9_, "Shift") == 0) {
					GdkModifierType _tmp10_;
					_tmp10_ = _vala_modifiers;
					_vala_modifiers = _tmp10_ | GDK_SHIFT_MASK;
				}
				_tmp11_ = modifier;
				if (g_strcmp0 (_tmp11_, "Super") == 0) {
					GdkModifierType _tmp12_;
					_tmp12_ = _vala_modifiers;
					_vala_modifiers = _tmp12_ | GDK_SUPER_MASK;
				}
				is_modifier = FALSE;
				start = pos + 1;
				_g_free0 (modifier);
			}
		}
		_tmp13_ = pos;
		pos = _tmp13_ + 1;
	}
	_tmp14_ = string_slice (name, (glong) start, (glong) pos);
	_tmp15_ = _tmp14_;
	_vala_keyval = gdk_keyval_from_name (_tmp15_);
	_g_free0 (_tmp15_);
	if (keyval) {
		*keyval = _vala_keyval;
	}
	if (modifiers) {
		*modifiers = _vala_modifiers;
	}
}

void
pomodoro_accelerator_unset (PomodoroAccelerator* self)
{
	g_return_if_fail (self != NULL);
	pomodoro_accelerator_set_key (self, (guint) 0);
	pomodoro_accelerator_set_modifiers (self, 0);
	g_signal_emit (self, pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL], 0);
}

static void
pomodoro_accelerator_normalize (guint* keyval,
                                GdkModifierType* modifiers)
{
	GdkModifierType keyval_modifier = 0U;
	GdkModifierType _tmp0_;
	keyval_modifier = 0;
	switch (*keyval) {
		case GDK_KEY_Control_L:
		case GDK_KEY_Control_R:
		{
			keyval_modifier = GDK_CONTROL_MASK;
			break;
		}
		case GDK_KEY_Shift_L:
		case GDK_KEY_Shift_R:
		{
			keyval_modifier = GDK_SHIFT_MASK;
			break;
		}
		case GDK_KEY_Super_L:
		case GDK_KEY_Super_R:
		{
			keyval_modifier = GDK_SUPER_MASK;
			break;
		}
		case GDK_KEY_Alt_L:
		case GDK_KEY_Alt_R:
		{
			keyval_modifier = GDK_MOD1_MASK;
			break;
		}
		default:
		break;
	}
	_tmp0_ = keyval_modifier;
	if (_tmp0_ != 0) {
		GdkModifierType _tmp1_;
		*keyval = (guint) 0;
		_tmp1_ = keyval_modifier;
		*modifiers = (*modifiers) | _tmp1_;
	}
	*modifiers = (*modifiers) & (((GDK_CONTROL_MASK | GDK_SHIFT_MASK) | GDK_SUPER_MASK) | GDK_MOD1_MASK);
}

void
pomodoro_accelerator_set_keyval (PomodoroAccelerator* self,
                                 guint keyval,
                                 GdkModifierType modifiers)
{
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	pomodoro_accelerator_normalize (&keyval, &modifiers);
	_tmp1_ = self->priv->_key;
	if (_tmp1_ != keyval) {
		_tmp0_ = TRUE;
	} else {
		GdkModifierType _tmp2_;
		_tmp2_ = self->priv->_modifiers;
		_tmp0_ = _tmp2_ != modifiers;
	}
	if (_tmp0_) {
		pomodoro_accelerator_set_key (self, keyval);
		pomodoro_accelerator_set_modifiers (self, modifiers);
		g_signal_emit (self, pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL], 0);
	}
}

void
pomodoro_accelerator_validate (PomodoroAccelerator* self,
                               GError** error)
{
	guint key = 0U;
	guint _tmp0_;
	GdkModifierType modifiers = 0U;
	GdkModifierType _tmp1_;
	gboolean _tmp2_ = FALSE;
	GdkModifierType _tmp4_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp11_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_key;
	key = _tmp0_;
	_tmp1_ = self->priv->_modifiers;
	modifiers = _tmp1_;
	if (key == ((guint) 0)) {
		GdkModifierType _tmp3_;
		_tmp3_ = modifiers;
		_tmp2_ = _tmp3_ == 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		return;
	}
	_tmp4_ = modifiers;
	if (!gtk_accelerator_valid (key, _tmp4_)) {
		GError* _tmp5_;
		_tmp5_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_INVALID, "Invalid");
		_inner_error0_ = _tmp5_;
		if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (key != ((guint) 0)) {
		GdkModifierType _tmp7_;
		_tmp7_ = modifiers;
		_tmp6_ = _tmp7_ == 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		if (key == GDK_KEY_Escape) {
			_tmp9_ = TRUE;
		} else {
			_tmp9_ = key == GDK_KEY_BackSpace;
		}
		if (_tmp9_) {
			_tmp8_ = TRUE;
		} else {
			_tmp8_ = key == GDK_KEY_Return;
		}
		if (_tmp8_) {
			GError* _tmp10_;
			_tmp10_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_FORBIDDEN, "Forbidden");
			_inner_error0_ = _tmp10_;
			if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	if (key != ((guint) 0)) {
		gboolean _tmp12_ = FALSE;
		GdkModifierType _tmp13_;
		_tmp13_ = modifiers;
		if (_tmp13_ == 0) {
			_tmp12_ = TRUE;
		} else {
			GdkModifierType _tmp14_;
			_tmp14_ = modifiers;
			_tmp12_ = _tmp14_ == GDK_SHIFT_MASK;
		}
		_tmp11_ = _tmp12_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_ = FALSE;
		if (key >= GDK_KEY_a) {
			_tmp25_ = key <= GDK_KEY_z;
		} else {
			_tmp25_ = FALSE;
		}
		if (_tmp25_) {
			_tmp24_ = TRUE;
		} else {
			gboolean _tmp26_ = FALSE;
			if (key >= GDK_KEY_A) {
				_tmp26_ = key <= GDK_KEY_Z;
			} else {
				_tmp26_ = FALSE;
			}
			_tmp24_ = _tmp26_;
		}
		if (_tmp24_) {
			_tmp23_ = TRUE;
		} else {
			gboolean _tmp27_ = FALSE;
			if (key >= GDK_KEY_0) {
				_tmp27_ = key <= GDK_KEY_9;
			} else {
				_tmp27_ = FALSE;
			}
			_tmp23_ = _tmp27_;
		}
		if (_tmp23_) {
			_tmp22_ = TRUE;
		} else {
			gboolean _tmp28_ = FALSE;
			if (key >= GDK_KEY_kana_fullstop) {
				_tmp28_ = key <= GDK_KEY_semivoicedsound;
			} else {
				_tmp28_ = FALSE;
			}
			_tmp22_ = _tmp28_;
		}
		if (_tmp22_) {
			_tmp21_ = TRUE;
		} else {
			gboolean _tmp29_ = FALSE;
			if (key >= GDK_KEY_Arabic_comma) {
				_tmp29_ = key <= GDK_KEY_Arabic_sukun;
			} else {
				_tmp29_ = FALSE;
			}
			_tmp21_ = _tmp29_;
		}
		if (_tmp21_) {
			_tmp20_ = TRUE;
		} else {
			gboolean _tmp30_ = FALSE;
			if (key >= GDK_KEY_Serbian_dje) {
				_tmp30_ = key <= GDK_KEY_Cyrillic_HARDSIGN;
			} else {
				_tmp30_ = FALSE;
			}
			_tmp20_ = _tmp30_;
		}
		if (_tmp20_) {
			_tmp19_ = TRUE;
		} else {
			gboolean _tmp31_ = FALSE;
			if (key >= GDK_KEY_Greek_ALPHAaccent) {
				_tmp31_ = key <= GDK_KEY_Greek_omega;
			} else {
				_tmp31_ = FALSE;
			}
			_tmp19_ = _tmp31_;
		}
		if (_tmp19_) {
			_tmp18_ = TRUE;
		} else {
			gboolean _tmp32_ = FALSE;
			if (key >= GDK_KEY_hebrew_doublelowline) {
				_tmp32_ = key <= GDK_KEY_hebrew_taf;
			} else {
				_tmp32_ = FALSE;
			}
			_tmp18_ = _tmp32_;
		}
		if (_tmp18_) {
			_tmp17_ = TRUE;
		} else {
			gboolean _tmp33_ = FALSE;
			if (key >= GDK_KEY_Thai_kokai) {
				_tmp33_ = key <= GDK_KEY_Thai_lekkao;
			} else {
				_tmp33_ = FALSE;
			}
			_tmp17_ = _tmp33_;
		}
		if (_tmp17_) {
			_tmp16_ = TRUE;
		} else {
			gboolean _tmp34_ = FALSE;
			if (key >= GDK_KEY_Hangul) {
				_tmp34_ = key <= GDK_KEY_Hangul_Special;
			} else {
				_tmp34_ = FALSE;
			}
			_tmp16_ = _tmp34_;
		}
		if (_tmp16_) {
			_tmp15_ = TRUE;
		} else {
			gboolean _tmp35_ = FALSE;
			if (key >= GDK_KEY_Hangul_Kiyeog) {
				_tmp35_ = key <= GDK_KEY_Hangul_J_YeorinHieuh;
			} else {
				_tmp35_ = FALSE;
			}
			_tmp15_ = _tmp35_;
		}
		if (_tmp15_) {
			GError* _tmp36_;
			_tmp36_ = g_error_new_literal (POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION, "Typing collision");
			_inner_error0_ = _tmp36_;
			if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	g_unichar_to_utf8 (self, str);
	result = str;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
pomodoro_accelerator_get_keys_internal (PomodoroAccelerator* self,
                                        gboolean escape,
                                        gint* result_length1)
{
	gchar** elements = NULL;
	gchar** _tmp0_;
	gint elements_length1;
	gint _elements_size_;
	GdkModifierType _tmp1_;
	GdkModifierType _tmp5_;
	GdkModifierType _tmp9_;
	GdkModifierType _tmp13_;
	guint _tmp17_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	elements = _tmp0_;
	elements_length1 = 0;
	_elements_size_ = elements_length1;
	_tmp1_ = self->priv->_modifiers;
	if ((_tmp1_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
		const gchar* _tmp2_ = NULL;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar* _tmp4_;
		if (escape) {
			_tmp2_ = "<Shift>";
		} else {
			_tmp2_ = "Shift";
		}
		_tmp3_ = elements;
		_tmp3__length1 = elements_length1;
		_tmp4_ = g_strdup (_tmp2_);
		_vala_array_add1 (&elements, &elements_length1, &_elements_size_, _tmp4_);
	}
	_tmp5_ = self->priv->_modifiers;
	if ((_tmp5_ & GDK_SUPER_MASK) == GDK_SUPER_MASK) {
		const gchar* _tmp6_ = NULL;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar* _tmp8_;
		if (escape) {
			_tmp6_ = "<Super>";
		} else {
			_tmp6_ = "Super";
		}
		_tmp7_ = elements;
		_tmp7__length1 = elements_length1;
		_tmp8_ = g_strdup (_tmp6_);
		_vala_array_add2 (&elements, &elements_length1, &_elements_size_, _tmp8_);
	}
	_tmp9_ = self->priv->_modifiers;
	if ((_tmp9_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
		const gchar* _tmp10_ = NULL;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		if (escape) {
			_tmp10_ = "<Ctrl>";
		} else {
			_tmp10_ = "Ctrl";
		}
		_tmp11_ = elements;
		_tmp11__length1 = elements_length1;
		_tmp12_ = g_strdup (_tmp10_);
		_vala_array_add3 (&elements, &elements_length1, &_elements_size_, _tmp12_);
	}
	_tmp13_ = self->priv->_modifiers;
	if ((_tmp13_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
		const gchar* _tmp14_ = NULL;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		if (escape) {
			_tmp14_ = "<Alt>";
		} else {
			_tmp14_ = "Alt";
		}
		_tmp15_ = elements;
		_tmp15__length1 = elements_length1;
		_tmp16_ = g_strdup (_tmp14_);
		_vala_array_add4 (&elements, &elements_length1, &_elements_size_, _tmp16_);
	}
	_tmp17_ = self->priv->_key;
	if (_tmp17_ != ((guint) 0)) {
		guint keyval = 0U;
		guint _tmp18_;
		gchar* name = NULL;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp18_ = self->priv->_key;
		keyval = gdk_keyval_to_upper (_tmp18_);
		_tmp19_ = gdk_keyval_name (keyval);
		_tmp20_ = g_strdup (_tmp19_);
		name = _tmp20_;
		if (escape) {
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			_tmp21_ = elements;
			_tmp21__length1 = elements_length1;
			_tmp22_ = name;
			_tmp23_ = g_strdup (_tmp22_);
			_vala_array_add5 (&elements, &elements_length1, &_elements_size_, _tmp23_);
		} else {
			gunichar key = 0U;
			gchar* _tmp24_ = NULL;
			gchar** _tmp28_;
			gint _tmp28__length1;
			gchar* _tmp29_;
			key = (gunichar) gdk_keyval_to_unicode (keyval);
			if (key > ((gunichar) 0)) {
				gchar* _tmp25_;
				_tmp25_ = g_unichar_to_string (key);
				_g_free0 (_tmp24_);
				_tmp24_ = _tmp25_;
			} else {
				const gchar* _tmp26_;
				gchar* _tmp27_;
				_tmp26_ = name;
				_tmp27_ = string_replace (_tmp26_, "_", " ");
				_g_free0 (_tmp24_);
				_tmp24_ = _tmp27_;
			}
			_tmp28_ = elements;
			_tmp28__length1 = elements_length1;
			_tmp29_ = g_strdup (_tmp24_);
			_vala_array_add6 (&elements, &elements_length1, &_elements_size_, _tmp29_);
			_g_free0 (_tmp24_);
		}
		_g_free0 (name);
	}
	_tmp30_ = elements;
	_tmp30__length1 = elements_length1;
	if (result_length1) {
		*result_length1 = _tmp30__length1;
	}
	result = _tmp30_;
	return result;
}

gchar**
pomodoro_accelerator_get_keys (PomodoroAccelerator* self,
                               gint* result_length1)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = pomodoro_accelerator_get_keys_internal (self, FALSE, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp0_;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

PomodoroAccelerator*
pomodoro_accelerator_construct (GType object_type)
{
	PomodoroAccelerator * self = NULL;
	self = (PomodoroAccelerator*) g_object_new (object_type, NULL);
	return self;
}

PomodoroAccelerator*
pomodoro_accelerator_new (void)
{
	return pomodoro_accelerator_construct (POMODORO_TYPE_ACCELERATOR);
}

static guint
pomodoro_accelerator_get_key (PomodoroAccelerator* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_key;
	return result;
}

static void
pomodoro_accelerator_set_key (PomodoroAccelerator* self,
                              guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_key = value;
}

static GdkModifierType
pomodoro_accelerator_get_modifiers (PomodoroAccelerator* self)
{
	GdkModifierType result;
	GdkModifierType _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}

static void
pomodoro_accelerator_set_modifiers (PomodoroAccelerator* self,
                                    GdkModifierType value)
{
	g_return_if_fail (self != NULL);
	self->priv->_modifiers = value;
}

gchar*
pomodoro_accelerator_get_name (PomodoroAccelerator* self)
{
	gchar* result;
	GString* name = NULL;
	GString* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	name = _tmp0_;
	_tmp2_ = pomodoro_accelerator_get_keys_internal (self, TRUE, &_tmp1_);
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
		element_collection = _tmp2_;
		element_collection_length1 = _tmp1_;
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
			gchar* _tmp3_;
			gchar* element = NULL;
			_tmp3_ = g_strdup (element_collection[element_it]);
			element = _tmp3_;
			{
				GString* _tmp4_;
				const gchar* _tmp5_;
				_tmp4_ = name;
				_tmp5_ = element;
				g_string_append (_tmp4_, _tmp5_);
				_g_free0 (element);
			}
		}
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp6_ = name;
	_tmp7_ = _tmp6_->str;
	_tmp8_ = g_strdup (_tmp7_);
	result = _tmp8_;
	_g_string_free0 (name);
	return result;
}

void
pomodoro_accelerator_set_name (PomodoroAccelerator* self,
                               const gchar* value)
{
	guint keyval = 0U;
	GdkModifierType modifiers = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
	GdkModifierType _tmp2_;
	g_return_if_fail (self != NULL);
	keyval = (guint) 0;
	modifiers = 0;
	pomodoro_accelerator_parse (value, &_tmp0_, &_tmp1_);
	keyval = _tmp0_;
	modifiers = _tmp1_;
	_tmp2_ = modifiers;
	pomodoro_accelerator_set_keyval (self, keyval, _tmp2_);
	g_object_notify_by_pspec ((GObject *) self, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NAME_PROPERTY]);
}

gchar*
pomodoro_accelerator_get_display_name (PomodoroAccelerator* self)
{
	gchar* result;
	GString* name = NULL;
	GString* _tmp0_;
	gboolean is_first = FALSE;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	name = _tmp0_;
	is_first = TRUE;
	_tmp2_ = pomodoro_accelerator_get_keys_internal (self, FALSE, &_tmp1_);
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
		element_collection = _tmp2_;
		element_collection_length1 = _tmp1_;
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
			gchar* _tmp3_;
			gchar* element = NULL;
			_tmp3_ = g_strdup (element_collection[element_it]);
			element = _tmp3_;
			{
				GString* _tmp5_;
				const gchar* _tmp6_;
				if (is_first) {
					is_first = FALSE;
				} else {
					GString* _tmp4_;
					_tmp4_ = name;
					g_string_append (_tmp4_, " + ");
				}
				_tmp5_ = name;
				_tmp6_ = element;
				g_string_append (_tmp5_, _tmp6_);
				_g_free0 (element);
			}
		}
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp7_ = name;
	_tmp8_ = _tmp7_->str;
	_tmp9_ = g_strdup (_tmp8_);
	result = _tmp9_;
	_g_string_free0 (name);
	return result;
}

static void
pomodoro_accelerator_real_changed (PomodoroAccelerator* self)
{
	g_object_notify ((GObject*) self, "name");
	g_object_notify ((GObject*) self, "display-name");
}

static void
pomodoro_accelerator_class_init (PomodoroAcceleratorClass * klass,
                                 gpointer klass_data)
{
	pomodoro_accelerator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PomodoroAccelerator_private_offset);
	((PomodoroAcceleratorClass *) klass)->changed = pomodoro_accelerator_real_changed;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_accelerator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_accelerator_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_accelerator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ACCELERATOR_NAME_PROPERTY, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY, pomodoro_accelerator_properties[POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	pomodoro_accelerator_signals[POMODORO_ACCELERATOR_CHANGED_SIGNAL] = g_signal_new ("changed", POMODORO_TYPE_ACCELERATOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroAcceleratorClass, changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
pomodoro_accelerator_instance_init (PomodoroAccelerator * self,
                                    gpointer klass)
{
	self->priv = pomodoro_accelerator_get_instance_private (self);
}

static void
pomodoro_accelerator_finalize (GObject * obj)
{
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
	G_OBJECT_CLASS (pomodoro_accelerator_parent_class)->finalize (obj);
}

GType
pomodoro_accelerator_get_type (void)
{
	static volatile gsize pomodoro_accelerator_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_accelerator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroAcceleratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_accelerator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroAccelerator), 0, (GInstanceInitFunc) pomodoro_accelerator_instance_init, NULL };
		GType pomodoro_accelerator_type_id;
		pomodoro_accelerator_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroAccelerator", &g_define_type_info, 0);
		PomodoroAccelerator_private_offset = g_type_add_instance_private (pomodoro_accelerator_type_id, sizeof (PomodoroAcceleratorPrivate));
		g_once_init_leave (&pomodoro_accelerator_type_id__volatile, pomodoro_accelerator_type_id);
	}
	return pomodoro_accelerator_type_id__volatile;
}

static void
_vala_pomodoro_accelerator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
	switch (property_id) {
		case POMODORO_ACCELERATOR_NAME_PROPERTY:
		g_value_take_string (value, pomodoro_accelerator_get_name (self));
		break;
		case POMODORO_ACCELERATOR_DISPLAY_NAME_PROPERTY:
		g_value_take_string (value, pomodoro_accelerator_get_display_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pomodoro_accelerator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	PomodoroAccelerator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator);
	switch (property_id) {
		case POMODORO_ACCELERATOR_NAME_PROPERTY:
		pomodoro_accelerator_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

