/* action.c generated by valac 0.46.6, the Vala compiler
 * generated from action.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <stdio.h>

#define ACTIONS_TYPE_ACTION (actions_action_get_type ())
#define ACTIONS_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACTIONS_TYPE_ACTION, ActionsAction))
#define ACTIONS_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACTIONS_TYPE_ACTION, ActionsActionClass))
#define ACTIONS_IS_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACTIONS_TYPE_ACTION))
#define ACTIONS_IS_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACTIONS_TYPE_ACTION))
#define ACTIONS_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACTIONS_TYPE_ACTION, ActionsActionClass))

typedef struct _ActionsAction ActionsAction;
typedef struct _ActionsActionClass ActionsActionClass;
typedef struct _ActionsActionPrivate ActionsActionPrivate;
typedef enum  {
	ACTIONS_STATE_NONE = 0,
	ACTIONS_STATE_POMODORO = 1,
	ACTIONS_STATE_SHORT_BREAK = 2,
	ACTIONS_STATE_LONG_BREAK = 4,
	ACTIONS_STATE_ANY = (ACTIONS_STATE_POMODORO | ACTIONS_STATE_SHORT_BREAK) | ACTIONS_STATE_LONG_BREAK
} ActionsState;

#define ACTIONS_TYPE_STATE (actions_state_get_type ())
typedef enum  {
	ACTIONS_TRIGGER_NONE = 0,
	ACTIONS_TRIGGER_START = 1,
	ACTIONS_TRIGGER_COMPLETE = 2,
	ACTIONS_TRIGGER_SKIP = 4,
	ACTIONS_TRIGGER_PAUSE = 8,
	ACTIONS_TRIGGER_RESUME = 16,
	ACTIONS_TRIGGER_ENABLE = 32,
	ACTIONS_TRIGGER_DISABLE = 64
} ActionsTrigger;

#define ACTIONS_TYPE_TRIGGER (actions_trigger_get_type ())
enum  {
	ACTIONS_ACTION_0_PROPERTY,
	ACTIONS_ACTION_NAME_PROPERTY,
	ACTIONS_ACTION_COMMAND_PROPERTY,
	ACTIONS_ACTION_PATH_PROPERTY,
	ACTIONS_ACTION_STATES_PROPERTY,
	ACTIONS_ACTION_TRIGGERS_PROPERTY,
	ACTIONS_ACTION_COMMAND_VALID_PROPERTY,
	ACTIONS_ACTION_NUM_PROPERTIES
};
static GParamSpec* actions_action_properties[ACTIONS_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define ACTIONS_TYPE_ACTION_MANAGER (actions_action_manager_get_type ())
#define ACTIONS_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACTIONS_TYPE_ACTION_MANAGER, ActionsActionManager))
#define ACTIONS_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACTIONS_TYPE_ACTION_MANAGER, ActionsActionManagerClass))
#define ACTIONS_IS_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACTIONS_TYPE_ACTION_MANAGER))
#define ACTIONS_IS_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACTIONS_TYPE_ACTION_MANAGER))
#define ACTIONS_ACTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACTIONS_TYPE_ACTION_MANAGER, ActionsActionManagerClass))

typedef struct _ActionsActionManager ActionsActionManager;
typedef struct _ActionsActionManagerClass ActionsActionManagerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define ACTIONS_TYPE_CONTEXT (actions_context_get_type ())
typedef struct _ActionsContext ActionsContext;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ActionsAction {
	GObject parent_instance;
	ActionsActionPrivate * priv;
};

struct _ActionsActionClass {
	GObjectClass parent_class;
};

struct _ActionsActionPrivate {
	gchar* _name;
	ActionsState _states;
	ActionsTrigger _triggers;
	gboolean _command_valid;
	gchar* _command;
	GSettings* settings;
	GSimpleAction* remove_action;
};

struct _ActionsContext {
	ActionsAction* action;
	ActionsTrigger triggers;
	ActionsState state;
	gdouble elapsed;
	gdouble duration;
};

static gint ActionsAction_private_offset;
static gpointer actions_action_parent_class = NULL;
static GType actions_action_type_id = 0;

GType actions_action_register_type (GTypeModule * module);
GType actions_action_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ActionsAction, g_object_unref)
GType actions_state_get_type (void) G_GNUC_CONST;
GType actions_trigger_get_type (void) G_GNUC_CONST;
ActionsAction* actions_action_new_for_path (const gchar* path);
ActionsAction* actions_action_construct_for_path (GType object_type,
                                                  const gchar* path);
void actions_action_set_path (ActionsAction* self,
                              const gchar* value);
void actions_action_reset (ActionsAction* self);
GActionGroup* actions_action_get_action_group (ActionsAction* self);
static void actions_action_activate_remove (ActionsAction* self,
                                     GSimpleAction* action,
                                     GVariant* parameter);
static void _actions_action_activate_remove_g_simple_action_activate (GSimpleAction* _sender,
                                                               GVariant* parameter,
                                                               gpointer self);
GType actions_action_manager_register_type (GTypeModule * module);
GType actions_action_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ActionsActionManager, g_object_unref)
ActionsActionManager* actions_action_manager_get_instance (void);
void actions_action_manager_remove (ActionsActionManager* self,
                                    ActionsAction* action);
static void actions_action_validate_command (ActionsAction* self);
const gchar* actions_action_get_command (ActionsAction* self);
static void actions_action_set_command_valid (ActionsAction* self,
                                       gboolean value);
GType actions_context_get_type (void) G_GNUC_CONST;
ActionsContext* actions_context_dup (const ActionsContext* self);
void actions_context_free (ActionsContext* self);
void actions_context_copy (const ActionsContext* self,
                           ActionsContext* dest);
void actions_context_destroy (ActionsContext* self);
gboolean actions_action_execute (ActionsAction* self,
                                 ActionsContext* context);
GList* actions_trigger_to_list (ActionsTrigger self);
gchar* actions_trigger_to_string (ActionsTrigger self);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gchar* actions_state_to_string (ActionsState self);
ActionsAction* actions_action_new (void);
ActionsAction* actions_action_construct (GType object_type);
const gchar* actions_action_get_name (ActionsAction* self);
void actions_action_set_name (ActionsAction* self,
                              const gchar* value);
void actions_action_set_command (ActionsAction* self,
                                 const gchar* value);
gchar* actions_action_get_path (ActionsAction* self);
ActionsState actions_action_get_states (ActionsAction* self);
void actions_action_set_states (ActionsAction* self,
                                ActionsState value);
ActionsTrigger actions_action_get_triggers (ActionsAction* self);
void actions_action_set_triggers (ActionsAction* self,
                                  ActionsTrigger value);
gboolean actions_action_get_command_valid (ActionsAction* self);
static void actions_action_finalize (GObject * obj);
static void _vala_actions_action_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_actions_action_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
actions_action_get_instance_private (ActionsAction* self)
{
	return G_STRUCT_MEMBER_P (self, ActionsAction_private_offset);
}

ActionsAction*
actions_action_construct_for_path (GType object_type,
                                   const gchar* path)
{
	ActionsAction * self = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	self = (ActionsAction*) g_object_new (object_type, NULL);
	actions_action_set_path (self, path);
	return self;
}

ActionsAction*
actions_action_new_for_path (const gchar* path)
{
	return actions_action_construct_for_path (ACTIONS_TYPE_ACTION, path);
}

/**
         * Reset action to defaults
         */
void
actions_action_reset (ActionsAction* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	g_settings_delay (_tmp0_);
	_tmp1_ = self->priv->settings;
	g_settings_reset (_tmp1_, "name");
	_tmp2_ = self->priv->settings;
	g_settings_reset (_tmp2_, "command");
	_tmp3_ = self->priv->settings;
	g_settings_reset (_tmp3_, "states");
	_tmp4_ = self->priv->settings;
	g_settings_reset (_tmp4_, "triggers");
	_tmp5_ = self->priv->settings;
	g_settings_apply (_tmp5_);
}

static void
_actions_action_activate_remove_g_simple_action_activate (GSimpleAction* _sender,
                                                          GVariant* parameter,
                                                          gpointer self)
{
	actions_action_activate_remove ((ActionsAction*) self, _sender, parameter);
}

GActionGroup*
actions_action_get_action_group (ActionsAction* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GActionGroup* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_simple_action_group_new ();
	action_group = _tmp0_;
	_tmp1_ = g_simple_action_new ("remove", NULL);
	_g_object_unref0 (self->priv->remove_action);
	self->priv->remove_action = _tmp1_;
	_tmp2_ = self->priv->remove_action;
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _actions_action_activate_remove_g_simple_action_activate, self, 0);
	_tmp3_ = self->priv->remove_action;
	g_action_map_add_action ((GActionMap*) action_group, (GAction*) _tmp3_);
	result = (GActionGroup*) action_group;
	return result;
}

static void
actions_action_activate_remove (ActionsAction* self,
                                GSimpleAction* action,
                                GVariant* parameter)
{
	ActionsActionManager* action_manager = NULL;
	ActionsActionManager* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = actions_action_manager_get_instance ();
	action_manager = _tmp0_;
	actions_action_manager_remove (action_manager, self);
	_g_object_unref0 (action_manager);
}

static void
actions_action_validate_command (ActionsAction* self)
{
	gchar** spawn_args = NULL;
	gint spawn_args_length1 = 0;
	gint _spawn_args_size_ = 0;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gboolean _tmp0_ = FALSE;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar** _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gboolean _tmp5_;
		_tmp1_ = actions_action_get_command (self);
		_tmp2_ = _tmp1_;
		_tmp5_ = g_shell_parse_argv (_tmp2_, &_tmp4_, &_tmp3_, &_inner_error0_);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = _tmp3_;
		spawn_args_length1 = _tmp4_;
		_spawn_args_size_ = spawn_args_length1;
		_tmp0_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SHELL_ERROR) {
				goto __catch2_g_shell_error;
			}
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		actions_action_set_command_valid (self, _tmp0_);
	}
	goto __finally2;
	__catch2_g_shell_error:
	{
		GError* _error_ = NULL;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		actions_action_set_command_valid (self, FALSE);
		_g_error_free0 (_error_);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch3_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch3_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally3;
	__catch3_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally3:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

gboolean
actions_action_execute (ActionsAction* self,
                        ActionsContext* context)
{
	gchar** spawn_env = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	gchar** spawn_args = NULL;
	gint spawn_args_length1 = 0;
	gint _spawn_args_size_ = 0;
	gchar** trigger_strings = NULL;
	gchar** _tmp2_;
	gint trigger_strings_length1;
	gint _trigger_strings_size_;
	ActionsContext _tmp3_;
	ActionsTrigger _tmp4_;
	GList* _tmp5_;
	gchar* command = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	ActionsContext _tmp13_;
	ActionsState _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	ActionsContext _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	ActionsContext _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	_tmp1_ = _tmp0_ = g_get_environ ();
	spawn_env = _tmp1_;
	spawn_env_length1 = _vala_array_length (_tmp0_);
	_spawn_env_size_ = spawn_env_length1;
	_tmp2_ = g_new0 (gchar*, 0 + 1);
	trigger_strings = _tmp2_;
	trigger_strings_length1 = 0;
	_trigger_strings_size_ = trigger_strings_length1;
	_tmp3_ = *context;
	_tmp4_ = _tmp3_.triggers;
	_tmp5_ = actions_trigger_to_list (_tmp4_);
	{
		GList* trigger_collection = NULL;
		GList* trigger_it = NULL;
		trigger_collection = _tmp5_;
		for (trigger_it = trigger_collection; trigger_it != NULL; trigger_it = trigger_it->next) {
			ActionsTrigger trigger = 0U;
			trigger = (ActionsTrigger) ((gintptr) trigger_it->data);
			{
				gchar** _tmp6_;
				gint _tmp6__length1;
				ActionsTrigger _tmp7_;
				gchar* _tmp8_;
				_tmp6_ = trigger_strings;
				_tmp6__length1 = trigger_strings_length1;
				_tmp7_ = trigger;
				_tmp8_ = actions_trigger_to_string (_tmp7_);
				_vala_array_add2 (&trigger_strings, &trigger_strings_length1, &_trigger_strings_size_, _tmp8_);
			}
		}
		(trigger_collection == NULL) ? NULL : (trigger_collection = (g_list_free (trigger_collection), NULL));
	}
	_tmp9_ = actions_action_get_command (self);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strdup (_tmp10_);
	command = _tmp11_;
	_tmp12_ = command;
	_tmp13_ = *context;
	_tmp14_ = _tmp13_.state;
	_tmp15_ = actions_state_to_string (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = string_replace (_tmp12_, "$(state)", _tmp16_);
	_g_free0 (command);
	command = _tmp17_;
	_g_free0 (_tmp16_);
	_tmp18_ = command;
	_tmp19_ = *context;
	_tmp20_ = double_to_string (_tmp19_.elapsed);
	_tmp21_ = _tmp20_;
	_tmp22_ = string_replace (_tmp18_, "$(elapsed)", _tmp21_);
	_g_free0 (command);
	command = _tmp22_;
	_g_free0 (_tmp21_);
	_tmp23_ = command;
	_tmp24_ = *context;
	_tmp25_ = double_to_string (_tmp24_.duration);
	_tmp26_ = _tmp25_;
	_tmp27_ = string_replace (_tmp23_, "$(duration)", _tmp26_);
	_g_free0 (command);
	command = _tmp27_;
	_g_free0 (_tmp26_);
	_tmp28_ = command;
	_tmp29_ = trigger_strings;
	_tmp29__length1 = trigger_strings_length1;
	_tmp30_ = _vala_g_strjoinv (" ", _tmp29_, (gint) _tmp29__length1);
	_tmp31_ = _tmp30_;
	_tmp32_ = string_replace (_tmp28_, "$(triggers)", _tmp31_);
	_g_free0 (command);
	command = _tmp32_;
	_g_free0 (_tmp31_);
	{
		const gchar* _tmp33_;
		gchar** _tmp34_ = NULL;
		gint _tmp35_ = 0;
		_tmp33_ = command;
		g_shell_parse_argv (_tmp33_, &_tmp35_, &_tmp34_, &_inner_error0_);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = _tmp34_;
		spawn_args_length1 = _tmp35_;
		_spawn_args_size_ = spawn_args_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp36_ = FALSE;
			if (_inner_error0_->domain == G_SHELL_ERROR) {
				goto __catch4_g_shell_error;
			}
			_g_free0 (command);
			trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp36_;
		}
	}
	goto __finally4;
	__catch4_g_shell_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp37_;
		GError* _tmp38_;
		const gchar* _tmp39_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp37_ = command;
		_tmp38_ = _error_;
		_tmp39_ = _tmp38_->message;
		g_debug ("action.vala:151: Error while executing command \"%s\": %s", _tmp37_, _tmp39_);
		result = FALSE;
		_g_error_free0 (_error_);
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally4:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp40_ = FALSE;
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp40_;
	}
	{
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar** _tmp42_;
		gint _tmp42__length1;
		_tmp41_ = spawn_args;
		_tmp41__length1 = spawn_args_length1;
		_tmp42_ = spawn_env;
		_tmp42__length1 = spawn_env_length1;
		g_spawn_sync ("/", _tmp41_, _tmp42_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp43_ = FALSE;
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch5_g_spawn_error;
			}
			_g_free0 (command);
			trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp43_;
		}
	}
	goto __finally5;
	__catch5_g_spawn_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp44_;
		GError* _tmp45_;
		const gchar* _tmp46_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp44_ = stdout;
		_tmp45_ = _error_;
		_tmp46_ = _tmp45_->message;
		fprintf (_tmp44_, "Error: %s\n", _tmp46_);
		result = FALSE;
		_g_error_free0 (_error_);
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp47_ = FALSE;
		_g_free0 (command);
		trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp47_;
	}
	result = TRUE;
	_g_free0 (command);
	trigger_strings = (_vala_array_free (trigger_strings, trigger_strings_length1, (GDestroyNotify) g_free), NULL);
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

ActionsAction*
actions_action_construct (GType object_type)
{
	ActionsAction * self = NULL;
	self = (ActionsAction*) g_object_new (object_type, NULL);
	return self;
}

ActionsAction*
actions_action_new (void)
{
	return actions_action_construct (ACTIONS_TYPE_ACTION);
}

const gchar*
actions_action_get_name (ActionsAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
actions_action_set_name (ActionsAction* self,
                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, actions_action_get_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_NAME_PROPERTY]);
	}
}

const gchar*
actions_action_get_command (ActionsAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_command;
	result = _tmp0_;
	return result;
}

void
actions_action_set_command (ActionsAction* self,
                            const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_command);
	self->priv->_command = _tmp0_;
	actions_action_validate_command (self);
	g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_COMMAND_PROPERTY]);
}

gchar*
actions_action_get_path (ActionsAction* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	GSettings* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->settings;
	if (_tmp1_ != NULL) {
		GSettings* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = self->priv->settings;
		g_object_get (_tmp2_, "path", &_tmp3_, NULL);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}

void
actions_action_set_path (ActionsAction* self,
                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (value != NULL) {
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		_tmp0_ = g_settings_new_with_path ("org.gnome.pomodoro.plugins.actions.action", value);
		_g_object_unref0 (self->priv->settings);
		self->priv->settings = _tmp0_;
		_tmp1_ = self->priv->settings;
		g_settings_bind (_tmp1_, "name", (GObject*) self, "name", G_SETTINGS_BIND_DEFAULT);
		_tmp2_ = self->priv->settings;
		g_settings_bind (_tmp2_, "command", (GObject*) self, "command", G_SETTINGS_BIND_DEFAULT);
		_tmp3_ = self->priv->settings;
		g_settings_bind (_tmp3_, "states", (GObject*) self, "states", G_SETTINGS_BIND_DEFAULT);
		_tmp4_ = self->priv->settings;
		g_settings_bind (_tmp4_, "triggers", (GObject*) self, "triggers", G_SETTINGS_BIND_DEFAULT);
	} else {
		_g_object_unref0 (self->priv->settings);
		self->priv->settings = NULL;
	}
	g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_PATH_PROPERTY]);
}

ActionsState
actions_action_get_states (ActionsAction* self)
{
	ActionsState result;
	ActionsState _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_states;
	result = _tmp0_;
	return result;
}

void
actions_action_set_states (ActionsAction* self,
                           ActionsState value)
{
	g_return_if_fail (self != NULL);
	if (actions_action_get_states (self) != value) {
		self->priv->_states = value;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_STATES_PROPERTY]);
	}
}

ActionsTrigger
actions_action_get_triggers (ActionsAction* self)
{
	ActionsTrigger result;
	ActionsTrigger _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_triggers;
	result = _tmp0_;
	return result;
}

void
actions_action_set_triggers (ActionsAction* self,
                             ActionsTrigger value)
{
	g_return_if_fail (self != NULL);
	if (actions_action_get_triggers (self) != value) {
		self->priv->_triggers = value;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_TRIGGERS_PROPERTY]);
	}
}

gboolean
actions_action_get_command_valid (ActionsAction* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_command_valid;
	return result;
}

static void
actions_action_set_command_valid (ActionsAction* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	if (actions_action_get_command_valid (self) != value) {
		self->priv->_command_valid = value;
		g_object_notify_by_pspec ((GObject *) self, actions_action_properties[ACTIONS_ACTION_COMMAND_VALID_PROPERTY]);
	}
}

static void
actions_action_class_init (ActionsActionClass * klass,
                           gpointer klass_data)
{
	actions_action_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ActionsAction_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_actions_action_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_actions_action_set_property;
	G_OBJECT_CLASS (klass)->finalize = actions_action_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_NAME_PROPERTY, actions_action_properties[ACTIONS_ACTION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_COMMAND_PROPERTY, actions_action_properties[ACTIONS_ACTION_COMMAND_PROPERTY] = g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_PATH_PROPERTY, actions_action_properties[ACTIONS_ACTION_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_STATES_PROPERTY, actions_action_properties[ACTIONS_ACTION_STATES_PROPERTY] = g_param_spec_flags ("states", "states", "states", ACTIONS_TYPE_STATE, ACTIONS_STATE_ANY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_TRIGGERS_PROPERTY, actions_action_properties[ACTIONS_ACTION_TRIGGERS_PROPERTY] = g_param_spec_flags ("triggers", "triggers", "triggers", ACTIONS_TYPE_TRIGGER, ACTIONS_TRIGGER_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACTIONS_ACTION_COMMAND_VALID_PROPERTY, actions_action_properties[ACTIONS_ACTION_COMMAND_VALID_PROPERTY] = g_param_spec_boolean ("command-valid", "command-valid", "command-valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
actions_action_instance_init (ActionsAction * self,
                              gpointer klass)
{
	self->priv = actions_action_get_instance_private (self);
	self->priv->_states = ACTIONS_STATE_ANY;
	self->priv->_triggers = ACTIONS_TRIGGER_NONE;
	self->priv->_command_valid = FALSE;
}

static void
actions_action_finalize (GObject * obj)
{
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACTIONS_TYPE_ACTION, ActionsAction);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_command);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->remove_action);
	G_OBJECT_CLASS (actions_action_parent_class)->finalize (obj);
}

GType
actions_action_get_type (void)
{
	return actions_action_type_id;
}

GType
actions_action_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ActionsActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) actions_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ActionsAction), 0, (GInstanceInitFunc) actions_action_instance_init, NULL };
	actions_action_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "ActionsAction", &g_define_type_info, 0);
	ActionsAction_private_offset = sizeof (ActionsActionPrivate);
	return actions_action_type_id;
}

static void
_vala_actions_action_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACTIONS_TYPE_ACTION, ActionsAction);
	switch (property_id) {
		case ACTIONS_ACTION_NAME_PROPERTY:
		g_value_set_string (value, actions_action_get_name (self));
		break;
		case ACTIONS_ACTION_COMMAND_PROPERTY:
		g_value_set_string (value, actions_action_get_command (self));
		break;
		case ACTIONS_ACTION_PATH_PROPERTY:
		g_value_take_string (value, actions_action_get_path (self));
		break;
		case ACTIONS_ACTION_STATES_PROPERTY:
		g_value_set_flags (value, actions_action_get_states (self));
		break;
		case ACTIONS_ACTION_TRIGGERS_PROPERTY:
		g_value_set_flags (value, actions_action_get_triggers (self));
		break;
		case ACTIONS_ACTION_COMMAND_VALID_PROPERTY:
		g_value_set_boolean (value, actions_action_get_command_valid (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_actions_action_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ActionsAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACTIONS_TYPE_ACTION, ActionsAction);
	switch (property_id) {
		case ACTIONS_ACTION_NAME_PROPERTY:
		actions_action_set_name (self, g_value_get_string (value));
		break;
		case ACTIONS_ACTION_COMMAND_PROPERTY:
		actions_action_set_command (self, g_value_get_string (value));
		break;
		case ACTIONS_ACTION_PATH_PROPERTY:
		actions_action_set_path (self, g_value_get_string (value));
		break;
		case ACTIONS_ACTION_STATES_PROPERTY:
		actions_action_set_states (self, g_value_get_flags (value));
		break;
		case ACTIONS_ACTION_TRIGGERS_PROPERTY:
		actions_action_set_triggers (self, g_value_get_flags (value));
		break;
		case ACTIONS_ACTION_COMMAND_VALID_PROPERTY:
		actions_action_set_command_valid (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

